;Project Lynxmotion Phoenix
;Description: Phoenix, configuration file.
;		All Hardware connections (excl controls) and body dimensions 
;		are configurated in this file. Can be used with V2.0 and above
;Configuration version: V1.0
;Date: 06-10-2009
;Programmer: Jeroen Janssen (aka Xan)
;
;Hardware setup: ABB2 with ATOM 28 Pro, SSC32 V2, (See further for connections)
;
;NEW IN V1.0
;	- First Release
;
;--------------------------------------------------------------------
;[SERIAL CONNECTIONS]
cSSC_OUT   		con P11		;Output pin for (SSC32 RX) on BotBoard (Yellow)
cSSC_IN    		con P10		;Input pin for (SSC32 TX) on BotBoard (Blue)
cSSC_BAUD 		con i38400	;SSC32 BAUD rate
;--------------------------------------------------------------------
;[BB2 PIN NUMBERS]
cEyesPin		con P8
;--------------------------------------------------------------------
;[SSC PIN NUMBERS]
cRRCoxaPin 		con P24	;Rear Right leg Hip Horizontal
cRRFemurPin 	con P25	;Rear Right leg Hip Vertical
cRRTibiaPin 	con P26	;Rear Right leg Knee
cRRTarsPin 		con P27

cRMCoxaPin 		con P20	;Middle Right leg Hip Horizontal
cRMFemurPin 	con P21	;Middle Right leg Hip Vertical
cRMTibiaPin 	con P22	;Middle Right leg Knee
cRMTarsPin 		con P23

cRFCoxaPin 		con P16	;Front Right leg Hip Horizontal
cRFFemurPin 	con P17	;Front Right leg Hip Vertical
cRFTibiaPin 	con P18	;Front Right leg Knee
cRFTarsPin 		con P19

cLRCoxaPin 		con P8	;Rear Left leg Hip Horizontal
cLRFemurPin 	con P9	;Rear Left leg Hip Vertical
cLRTibiaPin 	con P10	;Rear Left leg Knee
cLRTarsPin 		con P11

cLMCoxaPin 		con P4	;Middle Left leg Hip Horizontal
cLMFemurPin 	con P5	;Middle Left leg Hip Vertical
cLMTibiaPin 	con P6	;Middle Left leg Knee
cLMTarsPin 		con P7

cLFCoxaPin 		con P0	;Front Left leg Hip Horizontal
cLFFemurPin 	con P1	;Front Left leg Hip Vertical
cLFTibiaPin 	con P2	;Front Left leg Knee
cLFTarsPin 		con P3
;--------------------------------------------------------------------
;[SERVO Offsets]
cRFCoxaOffset 	con 650+2	;Front Right leg Hip Horizontal		
cRFFemurOffset 	con 650-67	;Front Right leg Hip Vertical	
cRFTibiaOffset  con 650+317	;Front Right leg Knee			
cRFTarsOffset 	con 650-396	;Front Right leg foot			

cRMCoxaOffset 	con 650-12	;Middle Right leg Hip Horizontal
cRMFemurOffset 	con 650-104	;Middle Right leg Hip Vertical		
cRMTibiaOffset  con 650+363	;Middle Right leg Knee			
cRMTarsOffset 	con 650-378	;Middle Right leg foot			

cRRCoxaOffset 	con 650-68	;Rear Right leg Hip Horizontal		
cRRFemurOffset 	con 650-32	;Rear Right leg Hip Vertical	
cRRTibiaOffset  con 650+438	;Rear Right leg Knee			
cRRTarsOffset 	con 650-289	;Rear Right leg foot			

cLFCoxaOffset 	con 650+89	;Front Left leg Hip Horizontal		
cLFFemurOffset 	con 650+183	;Front Left leg Hip Vertical		
cLFTibiaOffset  con 650-245	;Front Left leg Knee			
cLFTarsOffset 	con 650+416;Front Left leg foot			

cLMCoxaOffset 	con 650+58	;Middle Left leg Hip Horizontal	
cLMFemurOffset 	con 650+59	;Middle Left leg Hip Vertical		
cLMTibiaOffset  con 650-313	;Middle Left leg Knee				
cLMTarsOffset 	con 650+338	;Middle Left leg foot				

cLRCoxaOffset 	con 650-66	;Rear Left leg Hip Horizontal		
cLRFemurOffset 	con 650+115	;Rear Left leg Hip Vertical			
cLRTibiaOffset  con 650-405	;Rear Left leg Knee					
cLRTarsOffset 	con 650+356	;Rear Left leg foot					

;--------------------------------------------------------------------
;[MIN/MAX ANGLES]
cRRCoxaMin1		con -260	;Mechanical limits of the Right Rear Leg, decimals = 1
cRRCoxaMax1		con 740
cRRFemurMin1	con -1010
cRRFemurMax1	con 950
cRRTibiaMin1	con -1060
cRRTibiaMax1	con 770

cRMCoxaMin1		con -530	;Mechanical limits of the Right Middle Leg, decimals = 1
cRMCoxaMax1		con 530
cRMFemurMin1	con -1010
cRMFemurMax1	con 950
cRMTibiaMin1	con -1060
cRMTibiaMax1	con 770

cRFCoxaMin1		con -580	;Mechanical limits of the Right Front Leg, decimals = 1
cRFCoxaMax1		con 740
cRFFemurMin1	con -1010
cRFFemurMax1	con 950
cRFTibiaMin1	con -1060
cRFTibiaMax1	con 770

cLRCoxaMin1		con -740	;Mechanical limits of the Left Rear Leg, decimals = 1
cLRCoxaMax1		con 260
cLRFemurMin1	con -950
cLRFemurMax1	con 1010
cLRTibiaMin1	con -770
cLRTibiaMax1	con 1060

cLMCoxaMin1		con -530	;Mechanical limits of the Left Middle Leg, decimals = 1
cLMCoxaMax1		con 530
cLMFemurMin1	con -950
cLMFemurMax1	con 1010
cLMTibiaMin1	con -770
cLMTibiaMax1	con 1060

cLFCoxaMin1		con -740	;Mechanical limits of the Left Front Leg, decimals = 1
cLFCoxaMax1		con 580
cLFFemurMin1	con -950
cLFFemurMax1	con 1010
cLFTibiaMin1	con -770
cLFTibiaMax1	con 1060
;--------------------------------------------------------------------
;[BODY DIMENSIONS]
cCoxaLength  	con 29		;Length of the Coxa [mm]
cFemurLength 	con 75		;Length of the Femur [mm]
cTibiaLength 	con 71		;Lenght of the Tibia [mm]
cTarsLength		con	85		;Lenght of the Tars [mm]

cRRCoxaAngle1 	con -450	;Default Coxa setup angle, decimals = 1
cRMCoxaAngle1 	con 0		;Default Coxa setup angle, decimals = 1
cRFCoxaAngle1 	con 450		;Default Coxa setup angle, decimals = 1
cLRCoxaAngle1 	con -450	;Default Coxa setup angle, decimals = 1
cLMCoxaAngle1 	con 0		;Default Coxa setup angle, decimals = 1
cLFCoxaAngle1 	con 450		;Default Coxa setup angle, decimals = 1

cRROffsetX 		con -56		;Distance X from center of the body to the Right Rear coxa
cRROffsetZ 		con 102		;Distance Z from center of the body to the Right Rear coxa
cRMOffsetX 		con -75		;Distance X from center of the body to the Right Middle coxa
cRMOffsetZ 		con 0		;Distance Z from center of the body to the Right Middle coxa
cRFOffsetX 		con -63		;Distance X from center of the body to the Right Front coxa
cRFOffsetZ 		con -102	;Distance Z from center of the body to the Right Front coxa

cLROffsetX 		con 56		;Distance X from center of the body to the Left Rear coxa
cLROffsetZ 		con 102		;Distance Z from center of the body to the Left Rear coxa
cLMOffsetX 		con 75		;Distance X from center of the body to the Left Middle coxa
cLMOffsetZ 		con 0		;Distance Z from center of the body to the Left Middle coxa
cLFOffsetX 		con 63		;Distance X from center of the body to the Left Front coxa
cLFOffsetZ 		con -102	;Distance Z from center of the body to the Left Front coxa
;--------------------------------------------------------------------
;[START POSITIONS FEET]
cRRInitPosX 	con 72		;Start positions of the Right Rear leg
cRRInitPosY 	con 18
cRRInitPosZ 	con 72

cRMInitPosX 	con 102		;Start positions of the Right Middle leg
cRMInitPosY 	con 18
cRMInitPosZ 	con 0

cRFInitPosX 	con 72		;Start positions of the Right Front leg
cRFInitPosY 	con 18
cRFInitPosZ 	con -72

cLRInitPosX 	con 72		;Start positions of the Left Rear leg
cLRInitPosY 	con 18
cLRInitPosZ 	con 72

cLMInitPosX 	con 102		;Start positions of the Left Middle leg
cLMInitPosY 	con 18
cLMInitPosZ 	con 0

cLFInitPosX 	con 72		;Start positions of the Left Front leg
cLFInitPosY 	con 18
cLFInitPosZ 	con -72
;--------------------------------------------------------------------
;[Tars factors used in formula to calc Tarsus angle relative to the ground]
cTarsConst		con	720
cTarsMulti		con 2
cTarsFactorA	con 70'77
cTarsFactorB	con 70'65